unit Main;

{$mode objfpc}{$H+}

interface

uses
  Classes, ExtCtrls, PrintersDlgs, StdCtrls, SysUtils, FileUtil, Forms,
  Controls, Graphics, Dialogs, TAGraph, TASeries, TASources;

type

  { TForm1 }

  TForm1 = class(TForm)
    BarView: TChart;
    BarViewBarSeries1: TBarSeries;
    BarViewBarSeries2: TBarSeries;
    BarViewBarSeries3: TBarSeries;
    BarViewBarSeries4: TBarSeries;
    BarViewBarSeries5: TBarSeries;
    BarViewBarSeries6: TBarSeries;
    BarViewBarSeries7: TBarSeries;
    BarViewBarSeries8: TBarSeries;
    Button1: TButton;
    ListChartSource: TListChartSource;
    Panel1: TPanel;
    Print: TButton;
    PrintCanvas: TButton;
    PrintDialog1: TPrintDialog;
    procedure Button1Click(Sender: TObject);
    procedure PrintClick(Sender: TObject);
  end;

var
  Form1: TForm1; 

implementation

uses
  OSPrinters, TAPrint, Printers;

{$R *.lfm}

{ TForm1 }

procedure TForm1.PrintClick(Sender: TObject);
const
  MARGIN = 10;

var
  r: TRect;
  d: Integer;

begin

  if not PrintDialog1.Execute then exit;


  Printer.Begindoc;
  try
    r := Rect(0, 0, Printer.PageWidth, Printer.PageHeight div 2);
    d := r.Right - r.Left;
    r.Left += d div MARGIN;
    r.Right -= d div MARGIN;
    d := r.Bottom - r.Top;
    r.Top += d div MARGIN;
    r.Bottom -= d div MARGIN;

    if Sender = PrintCanvas then
      BarView.PaintOnCanvas(Printer.Canvas, r)
    else
      BarView.Draw(TPrinterDrawer.Create(Printer), r);
  finally
    Printer.EndDoc;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin

  BarViewBarSeries1.AddXY(0, 50, '0.1µm', clRed);
  BarViewBarSeries1.AddXY(1, 150, '0.2µm', clRed);
  BarViewBarSeries1.AddXY(2, 250, '0.3µm', clRed);
  BarViewBarSeries1.AddXY(3, 350, '0.5µm', clRed);
  BarViewBarSeries1.AddXY(4, 450, '0.7µm', clRed);
  BarViewBarSeries1.AddXY(5, 550, '1.0µm', clRed);
  BarViewBarSeries1.AddXY(6, 650, '2.0µm', clRed);
  BarViewBarSeries1.AddXY(7, 750, '5.0µm', clRed);


end;

end.

